/*
 * Copyright (c) 2020, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.wso2.micro.integrator.transport.handlers.utils;

/**
 * Constants used in swagger for data-services component.
 */
public class SwaggerProcessorConstants {

    public static final String SERVICES_PREFIX = "services";
    public static final String DATA_SERVICE_OBJECT = "org.wso2.ws.dataservice.dataservice.obj";
    public static final String SWAGGER_RESOURCE_PATH = "org.wso2.ws.dataservice.dataservice.swagger.path";
    public static final String TENANT_CONTEXT_PROPERTY_NAME = "tenant.config.contexts";
    public static final String STRING = "string";
    public static final String NUMBER = "number";
    public static final String INTEGER = "integer";
    public static final String BOOLEAN = "boolean";

    public static final String CONFIG_REG_PREFIX = "conf:";
    public static final String GOV_REG_PREFIX = "gov:";
    public static final String FILE_PREFIX = "file:";
}
