# 12 Workflows and human interactions

## Business use case narrative

A business process is typically a collection of related and structured activities or tasks, that depicts a business 
use case and produces a specific service or output. A process may have zero or more well-defined inputs and an output. 
During the execution of the business process, it executes its sub-processes synchronously or asynchronously for 
producing the final output. During the execution, it may interact with both humans or equipment.

For example, a banking customer requesting a bank loan is a simple process.

WSO2 EI-Business-Process runtime provide ability to executes business processes written using either the BPMN 2.0 
standard or WS-BPEL 2.0 with WS-Human Task 1.1 for workflows interacting with people.



## Sub-Scenarios
- [12.1 Create workflow/business process instance](12.1-create-workflow-business-process-instance)
- [12.2 Service orchestration](12.2-service-orchestration)
- [12.3 Execute Activities / Tasks](12.3-execute-activities-tasks)
- [12.4 Human Interaction](12.4-human-interaction)
- [12.5 Control flow within workflow/business process](12.5-control-flow-within-workflow-business-process)
- [12.6 Error handling](12.6-error-handling)
- [12.7 Compensation handling](12.7-compensation-handling)
- [12.8 Versioning](12.8-versioning)
